// IRJDX Module
// Jeffrey J Weimer
// developed from utilities created by J. Gutow
// SVN History: $Revision: 815 $ on $Date: 2008-07-08 13:26:10 -0500 (Tue, 08 Jul 2008) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version = 1.0

#pragma ModuleName=IRJDX

Static Function/S LoadJDX(ic,udFL)
	variable ic
	STRUCT udFLStandardStructure &udFL

	variable fileRef, firstx, lastx, points, ymult=1, jc=0
	string fileStr = StringFromList(ic,udFL.fileList)
	string theLine="", theHeader = "", v1, v2
	string theRegEx = "([0-9]+\.*[0-9]*), (-*[0-9]+\.*[0-9]*)"

	// read each file
		
	if (udFL.reportCtrl >= 1)
		print "... file ", fileStr
	endif
	
	if (strlen(udFL.pathStr)==0)
		Open/R fileRef fileStr
	else
		Open/R/P=tmpIRDatadir fileRef fileStr
	endif

	do
		FReadLine fileRef, theLine
		if (!GrepString(theLine[0,1],"[0-9]+"))
			if (stringmatch(theLine, "*NPOINTS*"))
				points = str2num(theLine[(strsearch(theLine, "=",0)+1), strlen(theLine)-1])
				make/O/N=(points) DataWave0, DataWave1
			endif
			if (stringmatch(theLine, "*FIRSTX*"))
				firstx = str2num(theLine[(strsearch(theLine, "=",0)+1), strlen(theLine)-1])
			endif
			if (stringmatch(theLine, "*LASTX*"))
				lastx = str2num(theLine[(strsearch(theLine, "=",0)+1), strlen(theLine)-1])
			endif
			if (stringmatch(theLine, "*YFACTOR*"))
				ymult= str2num(theLine[(strsearch(theLine, "=",0)+1), strlen(theLine)-1])
			endif
			theHeader += theLine
		else
			SplitString/E=theRegEx theLine, v1, v2
			wave xwave = DataWave0
			wave ywave = DataWave1
			xwave[jc] = str2num(v1)
			ywave[jc] = str2num(v2)
			jc+=1
		endif
	while (!stringmatch(theLine,"*##END=*"))

	close fileRef
	
	//store all the information in the wave scales or notes

	Note DataWave1, theHeader
	
	return "DataWave0;DataWave1;"

end