// IRNicCORE Module
// Jeffrey J Weimer
// developed from utilities created by J. Gutow
// SVN History: $Revision: 870 $ on $Date: 2008-07-22 14:54:27 -0500 (Tue, 22 Jul 2008) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version = 1.0

#pragma ModuleName=IRNicCORE

Static Function  ReadNicSection2(filenumber,secOffset, V_npnts, firstx, lastx, V_nscans, V_nBkgScans)
	variable filenumber,secOffset, &V_npnts, &firstx, &lastx, &V_nscans, &V_nBkgScans
	FSetPos filenumber,secOffset+4; FBinRead/B=0/F=3 filenumber,V_npnts
	FSetPos filenumber,secOffset+16; FBinRead/B=0/F=4 filenumber,firstx
	FBinRead/B=0/F=4 filenumber,lastx
	FSetPos filenumber,secOffset+36; FBinRead/B=0/F=3 filenumber,V_nscans
	FSetPos filenumber,secOffset+52; FBinRead/B=0/F=3 filenumber,V_nBkgScans
	return 0
end

Static Function ReadNicSection3(filenumber, SecOffset, DataWave)
	variable filenumber, SecOffset
	wave DataWave
//DoAlert 1,"Offset to Section 3 is " + num2str(SecOffset)
//if(V_flag!=1)
//	Abort
//endif
	FSetPos filenumber,secOffset
	FBinRead/B=0/F=4 filenumber,DataWave
	return 0
end

Static Function/S ReadNicSection4(FileVar, Pos)
	Variable FileVar, Pos//FileVar = filenumber, Pos=offset for the FSetPos function.
	String UserText
	string line
	
	UserText = ""
	FSetPos FileVar, Pos
	do
		FReadLine /T=(num2char(0)) FileVar, Line		// Read one line
		UserText=UserText+Line[0,strlen(Line)-2]+"\r"		
	while (strlen(Line)>1)						// Until end of string list
	return(UserText)
end

Static Function ReadNicSection27(filenumber, secOffset, S_Backdate, S_datatype, S_yaxislabel, S_Resolution, S_beamsplitter)
	variable filenumber, secOffset
	string &S_Backdate, &S_datatype, &S_yaxislabel, &S_Resolution, &S_beamsplitter
	string str
	//set all strings to empty to avoid problems
	S_Backdate = ""
	S_datatype=""
	S_yaxislabel=""
	S_Resolution =""
	S_Beamsplitter=""
	
	FSetPos filenumber,secOffset			//move to beginning of history section
	Do										//read strings until reach end of history section
		FReadLine filenumber,str
		if (stringmatch(str,"*Collect Sample*"))
			s_datatype = "Sample" 		//Data Type from the collect command
		endif
		if (stringmatch(str,"*Collect Background*"))
			s_datatype="Background"
		endif
		if (stringmatch(str,"*Background collected on*"))
		 	s_Backdate=str[26,strlen(str)-2]			// Date from Background Info
		 endif
		 if(stringmatch(str, "*Final Format*"))
		 	S_yaxislabel=str[16,strlen(str)-2];  //gets the axis label and the format of spectrum
		 endif
		 if (stringmatch(str, "*Resolution*"))
		 	S_resolution=str[14,20];				//gets the resolution
		 endif
		 //other things typically available here, but ignored are: the bench serial number and user name
	while (!stringmatch(Str, "\r" ))	 //stop when we get a blank line
	return 0											
end

Static Function ReadNicSection105(filenumber, secOffset, a,b,c) //don't know what this is???
	variable filenumber, secOffset, &a,&b,&c
	FSetPos filenumber,secOffset; FBinRead/B=0/F=2 filenumber,a
	FBinRead/B=0/F=2 filenumber,b
	FBinRead/B=0/F=2 filenumber,c
	return 0
end

Static Function /S ReadNicSection107(filenumber,secOffset) //TraceName data
	variable filenumber, secOffset
	string strTemp
	FSetPos filenumber,secOffset
	FReadLine/T="" filenumber,strTemp
	return (strTemp[0,strlen(strTemp)-2])
end

Static Function /S ReadNicSection148(filenumber,secOffset) //TraceName data in .SRS file
	variable filenumber, secOffset
	string strTemp
	FSetPos filenumber,secOffset+16
	FReadLine/T="" filenumber,strTemp
	return (strTemp[0,strlen(strTemp)-2])
end

Static Function ReadNicSection151(filenumber,secOffset, nspec, minperspec)
	variable filenumber, secOffset, &nspec, &minperspec
	variable spec1time, lastspectime, timeunits
	
	//get the time of first  spectrum (not returned, for sanity checking)
	FSetPos filenumber, (secOffset+2+4*16)
	FBinRead /B=0/F=4 filenumber, spec1time
	
	//get the time for the last spectrum (not returned, for sanity checking)
	FSetPos filenumber, (secOffset +2+4*17)
	FBinRead /B=0/F=4 filenumber, lastspectime
	
	//get delta in time
	FSetPos filenumber, (secOffset +2+4*18)
	FBinRead /B=0/F=4 filenumber, minperspec	
	
	//get the number of spectra although we don't use it for anything
	FSetPos filenumber, (secOffset+2*45)
	FBinRead /B=0/F=2 filenumber, nspec
	
	//check time units.  Units can be either seconds or minutes.  I cannot find where this information is except in text associated 
	//with each spectrum?.
	
end
