// IRNicSPA Module
// Jeffrey J Weimer
// developed from utilities created by J. Gutow
// SVN History: $Revision: 870 $ on $Date: 2008-07-22 14:54:27 -0500 (Tue, 22 Jul 2008) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version = 1.1

#pragma ModuleName=IRNicSPA

#include "udIRModule_NicCore"

Static Function/S LoadNicSPA(ic,udFL)
	STRUCT udFLStandardStructure &udFL
	variable ic

	string wList = ""
	string fileStr=StringFromList(ic,udFL.fileList)

	variable filenumber
	variable firstx, lastx, points, V_filetype, V_nspectra, nSec, secOffset, V_nscans, V_nBkgScans
	variable a, b, c, n, secType, secLength
	string nameforwave, executestring, str, title, S_vers, S_date, S_backDate, S_yaxislabel, UserText, S_datatype
	string S_resolution, s_beamsplitter, TraceName
	string noteStr=""

	//fill some strings
	title=""
	TraceName=""
	S_date=""
	S_Backdate = ""
	S_datatype=""
	S_yaxislabel="Absorbance"  //Default if not changed by data in the file.
	S_Resolution =""
	S_Beamsplitter=""
	UserText=""	

	// read each file
		
	if (udFL.reportCtrl >= 1)
		print "... file ", fileStr
	endif
	
	if (strlen(udFL.pathStr)==0)
		Open/R filenumber fileStr
	else
		Open/R/P=tmpIRDatadir filenumber fileStr
	endif
		
	FReadLine filenumber,str; S_vers=str[0,strlen(str)-2]								// data file type
	FSetPos filenumber,30; FReadLine/T="" filenumber,str; title=str[0,strlen(str)-2]		// title
	FSetPos filenumber,288; FBinRead/B=0/F=2 filenumber,V_FileType					// Must be 1
	FSetPos filenumber,292; FBinRead/B=0/F=2 filenumber,V_nspectra					// # of index sections
	FBinRead/B=0/F=2 filenumber,nSec													// # of sections
	n=0
	do
		FSetPos filenumber,304+16*n; FBinRead/B=0/F=2 filenumber,secType
		FBinRead/B=0/F=3 filenumber,secOffset
		FBinRead/B=0/F=3 filenumber,secLength
		//print "SecType:",SecType," SecOffset:",SecOffset," SecLength:",SecLength
		switch (secType)														// Select data type
			case 2:															// Spectral Header
				IRNicCORE#ReadNicSection2(filenumber,secOffset, points, firstx, lastx, V_nscans, V_nBkgScans)
				break
			case 3:															// Spectral Data
				make /O/n=(points) DataWave
				wave DataWave = DataWave
				IRNicCORE#ReadNicSection3(filenumber, SecOffset, DataWave)
				break
			case 4:															// User text
				UserText=IRNicCORE#ReadNicSection4(filenumber, secOffset)
				break
			case 27:															// History text
				IRNicCORE#ReadNicSection27(filenumber, secOffset, S_Backdate, S_datatype, S_yaxislabel, S_Resolution, S_beamsplitter)
				break
			case 105:														// Parameters don't know
				IRNicCORE#ReadNicSection105(filenumber, secOffset, a,b,c)
				break
			case 106:														// Parameters don't know
			//	FSetPos file,secOffset; FBinRead/B=0/F=2 file,wave1
				break
			case 107:														//trace name info
				TraceName =IRNicCORE#ReadNicSection107(filenumber, secOffset)
				break
			case 130:														//Parameters don't know
				break
		endswitch
		n+=1
	while (n<nSec)

	//store all the information in the wave scales or notes
	SetScale/I x firstx,lastx,DataWave
//	SetScale d 0,100,S_yaxislabel,DataWave
//	Note /K DataWave

	sprintf noteStr, "Title:%s\tTrace Name:%s\r", title, TraceName
	sprintf noteStr, "%sDate:%s\tBackground Date:%s\r", noteStr, S_date, S_Backdate
	sprintf noteStr, "%sData Type:%s\tResolution:%s\tScans:%d\tBackground Scans:%d\r", noteStr, s_datatype, S_resolution, V_nscans, V_nBkgScans
	sprintf noteStr, "%sY Label:%s\r", noteStr, S_yaxislabel
	sprintf noteStr, "%sUser Text:%s", noteStr, UserText
	
	sprintf noteStr, "<fileheader>\r%s\r</fileheader>", noteStr

	note DataWave, noteStr
	
//	Note DataWave, ("Title: "+title)
//	Note DataWave, ("TraceName: "+TraceName)
//	Note DataWave, ("Resolution: "+S_resolution)
//	Note DataWave, ("Date: "+S_date)
//	Note DataWave, ("Background date: "+S_Backdate)
//	Note DataWave, ("DataType:" + s_datatype)
//	Note DataWave, ("Number of Scans: "+num2str(V_nscans))
//	Note DataWave, ("Number of Background Scans: "+num2str(V_nBkgScans))
//	Note DataWave, ("UserText: "+UserText)
	
//	print ("Title: "+title)
//	print ("TraceName: "+TraceName)
//	print ("Resolution: "+S_resolution)
//	print ("Date: "+S_date)
//	print ("Background date: "+S_Backdate)
//	print ("DataType:" + s_datatype)
//	print ("Number of Scans: "+num2str(V_nscans))
//	print ("Number of Background Scans: "+num2str(V_nBkgScans))
//	print ("UserText: "+UserText)
	
//	//Now check to see that the x values increase with increasing point value.  If they don't than swap
//	//all the points end over end.
//	If (firstx > lastx) //we need to flip the wave to make sure some IGOR functions won't be confused.
//		SwapPointOrder(DataWave)
//	endif

//	//now let's rename the wave
//	nameforwave=FileNameOnly(Filename)
//	executestring = "duplicate/O DataWave,'"+nameforwave+"'"
//	Execute executestring
		
//	//Cleanup
//	print "data loaded into wave: ", nameforwave
//	killwaves DataWave

	wList = "DataWave;"
	
	return wList	
end