// IRNicSPG Module
// Jeffrey J Weimer
// developed from utilities created by J. Gutow
// SVN History: $Revision: 870 $ on $Date: 2008-07-22 14:54:27 -0500 (Tue, 22 Jul 2008) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version = 1.0

#pragma ModuleName=IRNicSPG

#include "udIRModule_NicCore"

Static Function/S LoadNicSPG(ic,udFL)
	STRUCT udFLStandardStructure &udFL
	variable ic

	string wList = ""
	string fileStr=StringFromList(ic,udFL.fileList)
	
	variable filenumber
	variable firstx, lastx, delta, points, FType, NumIndSec, NumSec, SecType, SecOffset, SecLength
	variable NumScan, NumBScan, n, V_nscans, V_nBkgScans, a, b, c, whichspec
	string nameforwave, executestring, NameIR, title,S_resolution, S_date, S_Backdate,s_datatype,UserText
	string ylabel, S_beamsplitter,strTemp, TraceName
	 
	//fill some strings
	title = ""
	TraceName=""
	NameIR = ""
	S_date=""
	S_Backdate = ""
	S_datatype=""
	ylabel=""
	S_Resolution =""
	S_Beamsplitter=""
	UserText=""	

	// read each file
		
	if (udFL.reportCtrl >= 1)
		print "... file ", fileStr
	endif
	
	if (strlen(udFL.pathStr)==0)
		Open/R filenumber fileStr
	else
		Open/R/P=tmpIRDatadir filenumber fileStr
	endif

 	FSetPos filenumber, 30
 	FReadLine /T=(num2char(0))  filenumber, NameIR			// Get name of spectrum
	FSetPos filenumber, 288
	FBinRead /B=0/F=2 filenumber,  FType						// Has to be FType=1
	FSetPos filenumber, 292
	FBinRead /B=0/F=2 filenumber, NumIndSec					// Number of index sections
	FBinRead /B=0/F=2 filenumber, NumSec						// Number of sections
	n=0
	whichspec=0
	do													// Read all sections
		FSetPos filenumber, (304+16*n)						// Start of section
		FBinRead /B=0/F=2 filenumber, SecType				// Type of section
		FBinRead /B=0/F=3 filenumber, SecOffset				// Get offset
		FBinRead /B=0/F=3 filenumber, SecLength				// Get length
		//print "SecType:",SecType," SecOffset:",SecOffset," SecLength:",SecLength
		switch (secType)														// Select data type
			case 2:															// Spectral Header
				whichspec=whichspec+1 //increment the spectrum counter
				if (whichspec!=1) //we're not on the first time through so this is a new spectrum
					//store data for previous spectrum in the wave note and wave scales
					nameforwave = "IRData_"+ num2str((whichspec-1))
					SetScale/I x firstx,lastx,"Wavenumbers",DataWave
					SetScale d 0,100,ylabel,DataWave
					Note/K DataWave
					Note DataWave, ("Title: "+NameIR)
					Note DataWave, ("TraceName: "+TraceName)
					Note DataWave, ("Resolution: "+S_resolution)
					Note DataWave, ("Date: "+S_date)
					Note DataWave, ("Background date: "+S_Backdate)
					Note DataWave, ("DataType:" + s_datatype)
					Note DataWave, ("Number of Scans: "+num2Str(V_nscans))
					Note DataWave, ("Number of Background Scans: "+num2Str(V_nBkgScans))
					Note DataWave, ("UserText: "+UserText)

//					//Now check to see that the x values increase with increasing point value.  If they don't than swap
//					//all the points end over end.
//					If (firstx > lastx) //we need to flip the wave to make sure some IGOR functions won't be confused.
//						SwapPointOrder(DataWave)
//					endif
	
					//now let's rename the wave
					duplicate/O DataWave $nameforwave
					wlist += nameforwave + ";"
					if (udFL.reportCtrl>1)
						print "data loaded into wave: ", nameforwave
					endif
				endif
				IRNicCORE#ReadNicSection2(filenumber,secOffset, points, firstx, lastx, V_nscans, V_nBkgScans)
				break
			case 3:															// Spectral Data
				make /o/n=(points) DataWave
				wave DataWave = DataWave
				IRNicCORE#ReadNicSection3(filenumber, SecOffset, DataWave)
				break
			case 4:															// User text
				UserText=IRNicCORE#ReadNicSection4(Filenumber, SecOffset)
				break
			case 27:															// History text
				IRNicCORE#ReadNicSection27(filenumber, secOffset, S_Backdate, S_datatype, ylabel, S_Resolution, S_beamsplitter)
				break
			case 105:														// Parameters don't know
				IRNicCORE#ReadNicSection105(filenumber, secOffset, a,b,c)
				break
			case 106:														// Parameters don't know
			//	FSetPos file,secOffset; FBinRead/B=0/F=2 file,wave1
				break
			case 107:														//trace name info
				TraceName =IRNicCORE#ReadNicSection107(filenumber, secOffset)
				break
			case 130:														//Parameters don't know
				break
		endswitch
		n=n+1											// Loop index	
	while (n<NumSec)									// Until last one is read
	
	//Now save the last wave loaded in.
	nameforwave = "IRData_"+ num2str((whichspec))
	SetScale/I x firstx,lastx,"Wavenumbers",DataWave
	SetScale d 0,100,ylabel,DataWave
	Note/K DataWave
	Note DataWave, ("Title: "+NameIR)
	Note DataWave, ("TraceName: "+TraceName)
	Note DataWave, ("Resolution: "+S_resolution)
	Note DataWave, ("Date: "+S_date)
	Note DataWave, ("Background date: "+S_Backdate)
	Note DataWave, ("DataType:" + s_datatype)
	Note DataWave, ("Number of Scans: "+num2Str(V_nscans))
	Note DataWave, ("Number of Background Scans: "+num2Str(V_nBkgScans))
	Note DataWave, ("UserText: "+UserText)

//	//Now check to see that the x values increase with increasing point value.  If they don't than swap
//	//all the points end over end.
//	If (firstx > lastx) //we need to flip the wave to make sure some IGOR functions won't be confused.
//		SwapPointOrder(DataWave)
//	endif

	//now let's rename the wave and cleanup
	duplicate/O DataWave $nameforwave
	wlist += nameforwave + ";"
	
	if (udFL.reportCtrl>1)
		print "data loaded into wave: ", nameforwave
	endif
	//now let's cleanup
	killwaves DataWave
	return wlist
end
