// IRPESP Module
// Jeffrey J Weimer
// developed from utilities created by J. Gutow
// SVN History: $Revision: 870 $ on $Date: 2008-07-22 14:54:27 -0500 (Tue, 22 Jul 2008) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version = 1.0

#pragma ModuleName=IRPESP

Static Function/S LoadPESP(ic, udFL)
	variable ic
	STRUCT udFLStandardStructure &udFL
	
	variable filenumber, firstx, lastx, delta, points
	string nameforwave, executestring, str, d_t, S_user, S_remark, S_spectrometer, S_detector, S_source
	string S_beamsplitter, response, xunits, title, S_yaxislabel, S_xaxislabel
	variable V_nscans, yscaling, V_offset

	string fileStr = StringFromList(ic,udFL.fileList)

	// read each file
		
	if (udFL.reportCtrl >= 1)
		print "... file ", fileStr
	endif
	
	if (strlen(udFL.pathStr)==0)
		Open/R filenumber fileStr
	else
		Open/R/P=tmpIRDatadir filenumber fileStr
	endif

	FReadLine filenumber,title														// data file title
	FReadLine filenumber,str; FReadLine filenumber,str
	FReadLine filenumber,str; d_t=str[1,strlen(str)-2]
	FReadLine filenumber,str; d_t=d_t+" - "+str[1,strlen(str)-2]
	FReadLine filenumber,str; FReadLine filenumber, str
	FReadLine filenumber,str; S_user=str[1,strlen(str)-2]
	FReadLine filenumber,str; S_remark=str[1,strlen(str)-2]
	FReadLine filenumber,str
	FReadLine filenumber,str; V_nscans=str2num(str[1,strlen(str)-2])
	FReadLine filenumber,str; FReadLine filenumber,str; FReadLine filenumber,str; FReadLine filenumber,str
	FReadLine filenumber,str; FReadLine filenumber,str; FReadLine filenumber,str; FReadLine filenumber,str
	FReadLine filenumber,str
	FReadLine filenumber,str; S_spectrometer="Perkin Elmer: Paragon "+str[1,strlen(str)-2]
	FReadLine filenumber,str; S_detector=str[1,strlen(str)-2]
	FReadLine filenumber,str; S_source=str[1,strlen(str)-2]
	FReadLine filenumber,str; S_beamsplitter=str[0,strlen(str)-2]
	FReadLine/T="#" filenumber,response											// HDR data
	FReadLine/T="#" filenumber,response											// GR data
	FReadLine filenumber,str; FReadLine filenumber, str; xunits=lowerstr(str[1,strlen(str)-2])
	FReadLine filenumber,str; S_yaxislabel=str[1,strlen(str)-1]+" [\U]"; S_xaxislabel="Wavenumber ["+xunits+"]"
	FReadLine filenumber,str; yscaling=str2num(str)											// Y-scaling factor
	FReadLine filenumber,str; V_offset=str2num(str)
	FReadLine filenumber,str; firstx=str2num(str); FReadLine filenumber,str; delta=str2num(str)
	FReadLine filenumber,str; points=str2num(str)
	FReadLine/T="#" filenumber, response											// DATA
	FReadLine/T=(num2char(10)) filenumber,response
	make /O/n=(points) DataWave
	wave DataWave = DataWave
	FBinRead/B=0/F=3 filenumber,DataWave
	SetScale/P x firstx,delta,DataWave
	// SetScale d 0,100,"%",DataWave
	// DataWave = DataWave*yscaling;
	
	//Store some of the interesting information
	Note DataWave, ("Title: "+title)
	Note DataWave, ("Date: "+d_t)
	Note DataWave, ("Remarks: "+S_remark)
	
	return "DataWave;"
end
