// IRPolaris Module
// Jeffrey J Weimer
// developed from utilities created by J. Gutow
// SVN History: $Revision: 815 $ on $Date: 2008-07-08 13:26:10 -0500 (Tue, 08 Jul 2008) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version = 1.0

#pragma ModuleName=IRPolaris

Static Function/S LoadPolaris(ic, udFL)
	variable ic
	STRUCT udFLStandardStructure &udFL

	variable fileRef, firstx, lastx, delta, points
	string fileStr = StringFromList(ic,udFL.fileList)

	// read each file
		
	if (udFL.reportCtrl >= 1)
		print "... file ", fileStr
	endif
	
	if (strlen(udFL.pathStr)==0)
		Open/R fileRef fileStr
	else
		Open/R/P=tmpIRDatadir fileRef fileStr
	endif

	FSetPos fileRef, 6  //skip first six bytes
	FBinRead/F=5 fileRef, firstx //starting value, 64 bit IEEE
	FBinRead/F=5 fileRef, lastx //ending value, 64 bit IEEE
	FSetPos fileRef, 292 //skip first 292 bytes
	FBinRead/F=5 fileRef, delta //spacing between values, 64 bit IEEE
	FSetPos fileRef, 300
	FBinRead/F=3 fileRef, points //number of points, signed 32 bit

	make/O/N=(points) DataWave
	wave DataWave = DataWave
	FSetPos fileRef, 512
	FBinRead/F=4 fileRef, DataWave //load the data
	Close fileRef

	SetScale/I x firstx,lastx, DataWave //set the axis scaling.

	return "DataWave;"
end
